diff --git a/src/common/exec.c b/src/common/exec.c
index f39b0a294b..90ac524ac5 100644
--- a/src/common/exec.c
+++ b/src/common/exec.c
@@ -25,6 +25,8 @@
 #include <sys/wait.h>
 #include <unistd.h>
 
+#include "pg_exec_relpath.h"
+
 /*
  * Hacky solution to allow expressing both frontend and backend error reports
  * in one macro call.  First argument of log_error is an errcode() call of
@@ -109,6 +111,66 @@ validate_exec(const char *path)
 	return is_x ? (is_r ? 0 : -2) : -1;
 }
 
+/*
+ * find_my_rootdir -- find an absolute path to the postgres installation
+ *
+ *  argv0 is the name passed on the command line
+ *  retpath is the output area (must be of size MAXPGPATH)
+ *  returns 0 if OK, -1 if error.
+ */
+int
+find_my_rootdir(const char *argv0, char *retpath)
+{
+	char	path[MAXPGPATH * 2];	/* room for relative path changes */
+
+	/*
+	 * Get path to my executable.  This should be somewhere in either
+	 * bindir or libexecdir, depending on who is calling.
+	 */
+	if (find_my_exec(argv0, path))
+		return -1;
+
+	/* Trim off program name and keep just directory */
+	*last_dir_separator(path) = '\0';
+	canonicalize_path(path);
+
+	/*
+	 * If our executable was in bindir or libexecdir, one of these
+	 * two will match and we can return the rootdir, otherwise we
+	 * don't know what the rootdir is and must return error.
+	 */
+	if (trim_path_suffix(path, BIN_SUFFIX, retpath) == 0)
+		return 0;
+	if (trim_path_suffix(path, LIBEXEC_SUFFIX, retpath) == 0)
+		return 0;
+	return -1;
+}
+
+int
+find_my_libexecdir(const char *argv0, char *retpath)
+{
+	/* Get the root directory based on my executable */
+	if (find_my_rootdir(argv0, retpath))
+		return -1;
+
+	/* Append the libexecdir suffix to the root directory */
+	strcpy(retpath + strlen(retpath), LIBEXEC_SUFFIX);
+	canonicalize_path(retpath);
+	return 0;
+}
+
+int
+find_my_bindir(const char *argv0, char *retpath)
+{
+	/* Get the root directory based on my executable */
+	if (find_my_rootdir(argv0, retpath))
+		return -1;
+
+	/* Append the bindir suffix to the root directory */
+	strcpy(retpath + strlen(retpath), BIN_SUFFIX);
+	canonicalize_path(retpath);
+	return 0;
+}
 
 /*
  * find_my_exec -- find an absolute path to a valid executable
@@ -314,6 +376,82 @@ resolve_symlinks(char *path)
 	return 0;
 }
 
+/*
+ * Helper function for find_other_cmd.  We have to change directories
+ * from 'path' to 'path/relpath' if and only if 'path' ends with 'suffix'.
+ * Then we check whether the target exists and is of the right version.
+ */
+static int
+check_cmd(const char *path, const char *suffix, const char *relpath,
+		  const char *target, const char *versionstr, char *retpath)
+{
+	char		cmd[MAXPGPATH];
+	char		line[MAXPGPATH];
+	int			pathlen = strlen(path);
+	int			suffixlen = strlen(suffix);
+
+	/* If our path ends with the given suffix, then we follow the relpath */
+	if (suffixlen <= pathlen && strcmp(path+pathlen-suffixlen, suffix) == 0)
+		snprintf(retpath, MAXPGPATH, "%s%s%s%s", path, relpath, target, EXE);
+	else
+		snprintf(retpath, MAXPGPATH, "%s/%s%s", path, target, EXE);
+
+	if (validate_exec(retpath) == 0)
+	{
+		snprintf(cmd, sizeof(cmd), "\"%s\" -V", retpath);
+		if (pipe_read_line(cmd, line, sizeof(line)))
+		{
+			if (strcmp(line, versionstr) != 0)
+				return -2;	/* wrong version */
+			return 0;
+		}
+	}
+
+	return -1;	/* not found */
+}
+
+
+/*
+ * Find another program and make sure it is the proper version.  Assuming our
+ * directory is either $(libexecdir) or $(bindir), this function will look in
+ * both of those directories, and in that order.  Otherwise, it will look in
+ * our directory.
+ *
+ * 'retpath' should point to memory at least MAXPGPATH in size.
+ */
+int
+find_other_cmd(const char *argv0, const char *target,
+				const char *versionstr, char *retpath)
+{
+	char		path[MAXPGPATH];
+	int			result;
+
+	if (find_my_exec(argv0, path) < 0)
+		return -1;
+
+	/* Trim off program name and keep just directory */
+	*last_dir_separator(path) = '\0';
+	canonicalize_path(path);
+
+	/*
+	 * If we are in neither the libexec nor bin directories, both attempts
+	 * below will check our current directory.  If the command is found in our
+	 * current directory, we return success (or wrong version) after just the
+	 * first attempt, and only on failure make the redundant attempt.  It
+	 * doesn't seem worth optimizing away the second attempt on failure, since
+	 * that should be rare anyway.
+	 */
+
+	/* Check libexec directory, or cwd if we're in some unexpected location */
+	result = check_cmd(path, BIN_SUFFIX, TO_LIBEXEC_RELPATH, target,
+					   versionstr, retpath);
+	if (result != -1)
+		return result;
+
+	/* Check bin directory, or cwd if we're in some unexpected location */
+	return check_cmd(path, LIBEXEC_SUFFIX, TO_BIN_RELPATH, target, versionstr,
+					 retpath);
+}
 
 /*
  * Find another program in our binary's directory,
@@ -435,6 +573,7 @@ set_pglocale_pgservice(const char *argv0, const char *app)
 {
 	char		path[MAXPGPATH];
 	char		my_exec_path[MAXPGPATH];
+	char		my_rootdir[MAXPGPATH];
 	char		env_path[MAXPGPATH + sizeof("PGSYSCONFDIR=")];	/* longer than
 																 * PGLOCALEDIR */
 	char	   *dup_path;
@@ -457,6 +596,8 @@ set_pglocale_pgservice(const char *argv0, const char *app)
 
 	if (find_my_exec(argv0, my_exec_path) < 0)
 		return;
+	if (find_my_rootdir(argv0, my_rootdir) < 0)
+		return;
 
 #ifdef ENABLE_NLS
 	get_locale_path(my_exec_path, path);
@@ -476,7 +617,7 @@ set_pglocale_pgservice(const char *argv0, const char *app)
 
 	if (getenv("PGSYSCONFDIR") == NULL)
 	{
-		get_etc_path(my_exec_path, path);
+		get_etc_path(my_rootdir, path);
 
 		/* set for libpq to use */
 		snprintf(env_path, sizeof(env_path), "PGSYSCONFDIR=%s", path);
diff --git a/src/common/mk_exec_relpath.pl b/src/common/mk_exec_relpath.pl
new file mode 100755
index 0000000000..c9ae667322
--- /dev/null
+++ b/src/common/mk_exec_relpath.pl
@@ -0,0 +1,85 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+
+# Some tools are located in the installation's bindir, but execute
+# commands located in the libexec directory.  Postgres's configure
+# script allows the user to override the defaults for bindir and libexecdir,
+# so we cannot assume the default that $(bindir)/../libexec is the libexecdir.
+# Nor can we assume that the $(libexec) dir from `make' will be the installed
+# path, as our commands are relocatable, and in any event they get installed
+# into a different directory for regression testing.
+#
+# We make the hopefully reasonable assumption that the relative path delta
+# between bindir and libexecdir is invariant, compute that here, and write it
+# to stdout.  The make system takes it from there.
+#
+# We are passed bindir and libexecdir on the command line.  For example,
+# C:\our\pg\foo\bin and C:\our\pg\some\other\libexecdir.  We generate a
+# relative path that can be used to cd from bindir into libexecdir.
+# For example, "../../some/other/libexecdir".  Note that we normalize to
+# unix style forward slashes.  We also generate the relative path going the
+# other way, from libexecdir back to bindir.
+#
+# TODO: What to do if the paths are windows style, and they are on differing
+# mounts?  For example, "C:\pg\bin" vs "D:\pg\libexec"
+#
+
+# Given two paths (or path suffixes) rooted at the same location, make a
+# relative path from the first to the second.
+sub make_relpath($$)
+{
+	my ($src, $dst) = @_;
+
+	# Replace path elements of src into '..', for example we would
+	# convert "foo/bin" into "../.."
+	$src =~ s{[^/]+}{..}g;
+
+	# Strip leading slash, if any, from both
+	$src =~ s{^/}{};
+	$dst =~ s{^/}{};
+
+	return join('/', $src, $dst);
+}
+
+my $bin = $ARGV[0];
+my $lib = $ARGV[1];
+
+# Create a separator that does not exist in either path argument.  We don't
+# need to be clever here.  We just keep appending spaces until we have
+# something suitable.
+my $sep = ' ';
+$sep .= ' ' while ($bin =~ m/$sep/ or $lib =~ m/$sep/);
+
+# Use a regex to find the longest common prefix of the two directories.  For
+# example, "C:\our\pg\".  We insist that the common prefix ends with a slash
+# character, such as "/" on unix or "C:\" on windows.
+#
+if ("${bin}${sep}${lib}" =~ m"^(.*[\\/])(.*?)${sep}\1(.*)$")
+{
+	# Record the suffixes of the two paths starting from where they diverge,
+	# for example, "foo\bin" and "some\other\libexecdir"
+	my ($binsuffix, $libsuffix) = ($2, $3);
+
+	# Replace windows specific directory separators in both suffixes to get,
+	# for example, "foo/bin" and "some/other/libexecdir"
+	$binsuffix =~ s{\\}{/}g;
+	$libsuffix =~ s{\\}{/}g;
+
+	# Print the two relative paths
+	printf("#ifndef PG_EXEC_RELPATH_H\n");
+	printf("#define PG_EXEC_RELPATH_H\n\n");
+	printf("#define LIBEXEC_SUFFIX \"%s\"\n", $libsuffix);
+	printf("#define BIN_SUFFIX \"%s\"\n", $binsuffix);
+	printf("#define TO_LIBEXEC_RELPATH \"/%s/\"\n",
+		make_relpath($binsuffix, $libsuffix));
+	printf("#define TO_BIN_RELPATH \"/%s/\"\n\n",
+		make_relpath($libsuffix, $binsuffix));
+	printf("#endif			/* PG_EXEC_RELPATH_H */\n");
+
+	# Successful return
+	exit 0;
+}
+warn "Cannot construct relative path for changing directories from $bin to $lib";
+exit 1;
diff --git a/src/include/common/config_info.h b/src/include/common/config_info.h
index f36b7838d0..ce24036550 100644
--- a/src/include/common/config_info.h
+++ b/src/include/common/config_info.h
@@ -16,6 +16,7 @@ typedef struct ConfigData
 } ConfigData;
 
 extern ConfigData *get_configdata(const char *my_exec_path,
+								  const char *my_rootdir,
 								  size_t *configdata_len);
 
 #endif							/* COMMON_CONFIG_INFO_H */
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index 14fa127ab1..f5cb2972c8 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -172,6 +172,7 @@ extern int	MyPMChildSlot;
 
 extern char OutputFileName[];
 extern PGDLLIMPORT char my_exec_path[];
+extern PGDLLIMPORT char my_rootdir[];
 extern char pkglib_path[];
 
 #ifdef EXEC_BACKEND
diff --git a/src/include/port.h b/src/include/port.h
index 271ff0d00b..afbcee9def 100644
--- a/src/include/port.h
+++ b/src/include/port.h
@@ -57,17 +57,20 @@ extern bool path_is_relative_and_below_cwd(const char *path);
 extern bool path_is_prefix_of_path(const char *path1, const char *path2);
 extern char *make_absolute_path(const char *path);
 extern const char *get_progname(const char *argv0);
+extern int trim_path_suffix(const char *path, const char *suffix, char *ret_path);
+extern void get_bin_path(const char *my_rootdir, char *ret_path);
 extern void get_share_path(const char *my_exec_path, char *ret_path);
-extern void get_etc_path(const char *my_exec_path, char *ret_path);
+extern void get_etc_path(const char *my_rootdir, char *ret_path);
 extern void get_include_path(const char *my_exec_path, char *ret_path);
 extern void get_pkginclude_path(const char *my_exec_path, char *ret_path);
-extern void get_includeserver_path(const char *my_exec_path, char *ret_path);
-extern void get_lib_path(const char *my_exec_path, char *ret_path);
+extern void get_includeserver_path(const char *my_rootdir, char *ret_path);
+extern void get_lib_path(const char *my_rootdir, char *ret_path);
+extern void get_libexec_path(const char *my_rootdir, char *ret_path);
 extern void get_pkglib_path(const char *my_exec_path, char *ret_path);
 extern void get_locale_path(const char *my_exec_path, char *ret_path);
-extern void get_doc_path(const char *my_exec_path, char *ret_path);
-extern void get_html_path(const char *my_exec_path, char *ret_path);
-extern void get_man_path(const char *my_exec_path, char *ret_path);
+extern void get_doc_path(const char *my_rootdir, char *ret_path);
+extern void get_html_path(const char *my_rootdir, char *ret_path);
+extern void get_man_path(const char *my_rootdir, char *ret_path);
 extern bool get_home_path(char *ret_path);
 extern void get_parent_directory(char *path);
 
@@ -103,9 +106,14 @@ extern void pgfnames_cleanup(char **filenames);
 extern void set_pglocale_pgservice(const char *argv0, const char *app);
 
 /* Portable way to find and execute binaries (in exec.c) */
+extern int	find_my_rootdir(const char *argv0, char *retpath);
+extern int	find_my_libexecdir(const char *argv0, char *retpath);
+extern int	find_my_bindir(const char *argv0, char *retpath);
 extern int	find_my_exec(const char *argv0, char *retpath);
 extern int	find_other_exec(const char *argv0, const char *target,
 							const char *versionstr, char *retpath);
+extern int	find_other_cmd(const char *argv0, const char *target,
+						   const char *versionstr, char *retpath);
 extern char *pipe_read_line(char *cmd, char *line, int maxsize);
 
 /* Doesn't belong here, but this is used with find_other_exec(), so... */
diff --git a/src/interfaces/ecpg/test/Makefile b/src/interfaces/ecpg/test/Makefile
index be53b7b94d..fe337c91e1 100644
--- a/src/interfaces/ecpg/test/Makefile
+++ b/src/interfaces/ecpg/test/Makefile
@@ -80,14 +80,14 @@ endif
 REGRESS_OPTS = --dbname=ecpg1_regression,ecpg2_regression --create-role=regress_ecpg_user1,regress_ecpg_user2 $(EXTRA_REGRESS_OPTS)
 
 check: all
-	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
+	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= --libexecdir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
 
 # Connect to the server using TCP, and add a TCP-specific test.
 checktcp: all | temp-install
-	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule --host=localhost sql/twophase connect/test1
+	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= --libexecdir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule --host=localhost sql/twophase connect/test1
 
 installcheck: all
-	./pg_regress $(REGRESS_OPTS) --bindir='$(bindir)' $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule
+	./pg_regress $(REGRESS_OPTS) --bindir='$(bindir)' --libexecdir='$(libexecdir)'$(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule
 
 # Versions of the check tests that include the twophase commit test.
 # It only makes sense to run these if set up to use prepared transactions,
@@ -95,7 +95,7 @@ installcheck: all
 # installcheck case.
 
 installcheck-prepared-txns: all
-	./pg_regress $(REGRESS_OPTS) --bindir='$(bindir)' $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
+	./pg_regress $(REGRESS_OPTS) --bindir='$(bindir)' --libexecdir='$(libexecdir)'$(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
 
 check-prepared-txns: all | temp-install
-	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
+	$(with_temp_install) ./pg_regress $(REGRESS_OPTS) --temp-instance=./tmp_check $(TEMP_CONF) --bindir= --libexecdir= $(pg_regress_locale_flags) $(THREAD) --schedule=$(srcdir)/ecpg_schedule sql/twophase
diff --git a/src/port/Makefile b/src/port/Makefile
index 8defa1257b..ce23e9ed85 100644
--- a/src/port/Makefile
+++ b/src/port/Makefile
@@ -145,6 +145,7 @@ path_srv.o: path.c pg_config_paths.h
 # available to configure.
 pg_config_paths.h: $(top_builddir)/src/Makefile.global
 	echo "#define PGBINDIR \"$(bindir)\"" >$@
+	echo "#define PGLIBEXECDIR \"$(libexecdir)\"" >>$@
 	echo "#define PGSHAREDIR \"$(datadir)\"" >>$@
 	echo "#define SYSCONFDIR \"$(sysconfdir)\"" >>$@
 	echo "#define INCLUDEDIR \"$(includedir)\"" >>$@
diff --git a/src/port/path.c b/src/port/path.c
index 10e87fbae8..88defa3080 100644
--- a/src/port/path.c
+++ b/src/port/path.c
@@ -48,6 +48,8 @@ static void make_relative_path(char *ret_path, const char *target_path,
 							   const char *bin_path, const char *my_exec_path);
 static void trim_directory(char *path);
 static void trim_trailing_separator(char *path);
+static void append_path_suffix(char *ret_path, const char *rootpath,
+							   const char *suffix);
 
 
 /*
@@ -588,6 +590,65 @@ no_match:
 	canonicalize_path(ret_path);
 }
 
+void
+append_path_suffix(char *ret_path, const char *rootpath, const char *suffix)
+{
+	char	buffer[MAXPGPATH*2];
+
+	snprintf(buffer, MAXPGPATH*2, "%s/%s", rootpath, suffix);
+	canonicalize_path(buffer);
+	strlcpy(ret_path, buffer, MAXPGPATH);
+}
+
+/*
+ * trim_path_suffix
+ *
+ * If the given suffix matches the end of the path, store the prefix
+ * in ret_path.  Returns zero on success, -1 if the suffix does not match.
+ * Note that matching is done on whole path components, such that
+ * "cd/ef" is a suffix of "ab/cd/ef" but not a suffix of "abcd/ef".
+ *
+ * ret_path must be a buffer at least MAXPGPATH in length.
+ */
+int
+trim_path_suffix(const char *path, const char *suffix, char *ret_path)
+{
+	int		pathlen = strlen(path);
+	int		suffixlen = strlen(suffix);
+	int		tail_start;
+
+	if (suffixlen > pathlen)
+		return -1;
+
+	/*
+	 * We consider a path to be a suffix of itself, though this does
+	 * result in a zero-length prefix in the ret_path.
+	 */
+	if (suffixlen == pathlen)
+	{
+		if (dir_strcmp(path, suffix))
+			return -1;
+		ret_path[0] = '\0';
+		return 0;
+	}
+
+	/*
+	 * Tail match?
+	 */
+	tail_start = pathlen - suffixlen;
+	if ((IS_DIR_SEP(path[tail_start - 1]) ||
+		 (IS_DIR_SEP(path[tail_start]) && IS_DIR_SEP(suffix[0]))) &&
+		dir_strcmp(path + tail_start, suffix) == 0)
+	{
+		strncpy(ret_path, path, tail_start);
+		ret_path[tail_start] = '\0';
+		canonicalize_path(ret_path);
+		return 0;
+	}
+
+	return -1;
+}
+
 
 /*
  * make_absolute_path
@@ -697,6 +758,15 @@ make_absolute_path(const char *path)
 }
 
 
+/*
+ *	get_bin_path
+ */
+void
+get_bin_path(const char *my_rootdir, char *ret_path)
+{
+	append_path_suffix(ret_path, my_rootdir, PGBINDIR);
+}
+
 /*
  *	get_share_path
  */
@@ -710,9 +780,9 @@ get_share_path(const char *my_exec_path, char *ret_path)
  *	get_etc_path
  */
 void
-get_etc_path(const char *my_exec_path, char *ret_path)
+get_etc_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, SYSCONFDIR, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, SYSCONFDIR);
 }
 
 /*
@@ -737,18 +807,27 @@ get_pkginclude_path(const char *my_exec_path, char *ret_path)
  *	get_includeserver_path
  */
 void
-get_includeserver_path(const char *my_exec_path, char *ret_path)
+get_includeserver_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, INCLUDEDIRSERVER, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, INCLUDEDIRSERVER);
 }
 
 /*
  *	get_lib_path
  */
 void
-get_lib_path(const char *my_exec_path, char *ret_path)
+get_lib_path(const char *my_rootdir, char *ret_path)
+{
+	append_path_suffix(ret_path, my_rootdir, LIBDIR);
+}
+
+/*
+ *	get_libexec_path
+ */
+void
+get_libexec_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, LIBDIR, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, PGLIBEXECDIR);
 }
 
 /*
@@ -773,27 +852,27 @@ get_locale_path(const char *my_exec_path, char *ret_path)
  *	get_doc_path
  */
 void
-get_doc_path(const char *my_exec_path, char *ret_path)
+get_doc_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, DOCDIR, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, DOCDIR);
 }
 
 /*
  *	get_html_path
  */
 void
-get_html_path(const char *my_exec_path, char *ret_path)
+get_html_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, HTMLDIR, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, HTMLDIR);
 }
 
 /*
  *	get_man_path
  */
 void
-get_man_path(const char *my_exec_path, char *ret_path)
+get_man_path(const char *my_rootdir, char *ret_path)
 {
-	make_relative_path(ret_path, MANDIR, PGBINDIR, my_exec_path);
+	append_path_suffix(ret_path, my_rootdir, MANDIR);
 }
 
 
diff --git a/src/test/isolation/isolation_main.c b/src/test/isolation/isolation_main.c
index 50916b00dc..8006518543 100644
--- a/src/test/isolation/isolation_main.c
+++ b/src/test/isolation/isolation_main.c
@@ -42,8 +42,8 @@ isolation_start_test(const char *testname,
 	if (!looked_up_isolation_exec)
 	{
 		/* look for isolationtester binary */
-		if (find_other_exec(saved_argv0, "isolationtester",
-							PG_ISOLATION_VERSIONSTR, isolation_exec) != 0)
+		if (find_other_cmd(saved_argv0, "isolationtester",
+						   PG_ISOLATION_VERSIONSTR, isolation_exec) != 0)
 		{
 			fprintf(stderr, _("could not find proper isolationtester binary\n"));
 			exit(2);
@@ -122,11 +122,11 @@ isolation_init(int argc, char **argv)
 	size_t		argv0_len;
 
 	/*
-	 * We unfortunately cannot do the find_other_exec() lookup to find the
+	 * We unfortunately cannot do the find_other_cmd() lookup to find the
 	 * "isolationtester" binary here.  regression_main() calls the
 	 * initialization functions before parsing the commandline arguments and
 	 * thus hasn't changed the library search path at this point which in turn
-	 * can cause the "isolationtester -V" invocation that find_other_exec()
+	 * can cause the "isolationtester -V" invocation that find_other_cmd()
 	 * does to fail since it's linked to libpq.  So we instead copy argv[0]
 	 * and do the lookup the first time through isolation_start_test().
 	 */
diff --git a/src/test/regress/pg_regress.c b/src/test/regress/pg_regress.c
index 38b2b1e8e1..fb4fba6695 100644
--- a/src/test/regress/pg_regress.c
+++ b/src/test/regress/pg_regress.c
@@ -75,6 +75,7 @@ bool		debug = false;
 char	   *inputdir = ".";
 char	   *outputdir = ".";
 char	   *bindir = PGBINDIR;
+char	   *libexecdir = PGLIBEXECDIR;
 char	   *launcher = NULL;
 static _stringlist *loadextension = NULL;
 static int	max_connections = 0;
@@ -269,8 +270,8 @@ stop_postmaster(void)
 
 		snprintf(buf, sizeof(buf),
 				 "\"%s%spg_ctl\" stop -D \"%s/data\" -s",
-				 bindir ? bindir : "",
-				 bindir ? "/" : "",
+				 libexecdir ? libexecdir : "",
+				 libexecdir ? "/" : "",
 				 temp_instance);
 		r = system(buf);
 		if (r != 0)
@@ -2037,6 +2038,8 @@ help(void)
 	printf(_("Options:\n"));
 	printf(_("      --bindir=BINPATH          use BINPATH for programs that are run;\n"));
 	printf(_("                                if empty, use PATH from the environment\n"));
+	printf(_("      --libexecdir=LIBEXECPATH  use LIBEXECPATH for commands that are run;\n"));
+	printf(_("                                if empty, use PATH from the environment\n"));
 	printf(_("      --config-auth=DATADIR     update authentication settings for DATADIR\n"));
 	printf(_("      --create-role=ROLE        create the specified role before testing\n"));
 	printf(_("      --dbname=DB               use database DB (default \"regression\")\n"));
@@ -2095,12 +2098,13 @@ regression_main(int argc, char *argv[], init_function ifunc, test_function tfunc
 		{"port", required_argument, NULL, 14},
 		{"user", required_argument, NULL, 15},
 		{"bindir", required_argument, NULL, 16},
-		{"dlpath", required_argument, NULL, 17},
-		{"create-role", required_argument, NULL, 18},
-		{"temp-config", required_argument, NULL, 19},
-		{"use-existing", no_argument, NULL, 20},
+		{"libexecdir", required_argument, NULL, 17},
+		{"dlpath", required_argument, NULL, 18},
+		{"create-role", required_argument, NULL, 19},
+		{"temp-config", required_argument, NULL, 20},
+		{"use-existing", no_argument, NULL, 21},
 		{"launcher", required_argument, NULL, 21},
-		{"load-extension", required_argument, NULL, 22},
+		{"load-extension", required_argument, NULL, 23},
 		{"config-auth", required_argument, NULL, 24},
 		{"max-concurrent-tests", required_argument, NULL, 25},
 		{NULL, 0, NULL, 0}
@@ -2209,21 +2213,28 @@ regression_main(int argc, char *argv[], init_function ifunc, test_function tfunc
 					bindir = NULL;
 				break;
 			case 17:
-				dlpath = pg_strdup(optarg);
+				/* "--libexecdir=" means to use PATH */
+				if (strlen(optarg))
+					libexecdir = pg_strdup(optarg);
+				else
+					libexecdir = NULL;
 				break;
 			case 18:
-				split_to_stringlist(optarg, ",", &extraroles);
+				dlpath = pg_strdup(optarg);
 				break;
 			case 19:
-				add_stringlist_item(&temp_configs, optarg);
+				split_to_stringlist(optarg, ",", &extraroles);
 				break;
 			case 20:
-				use_existing = true;
+				add_stringlist_item(&temp_configs, optarg);
 				break;
 			case 21:
-				launcher = pg_strdup(optarg);
+				use_existing = true;
 				break;
 			case 22:
+				launcher = pg_strdup(optarg);
+				break;
+			case 23:
 				add_stringlist_item(&loadextension, optarg);
 				break;
 			case 24:
@@ -2319,8 +2330,8 @@ regression_main(int argc, char *argv[], init_function ifunc, test_function tfunc
 		header(_("initializing database system"));
 		snprintf(buf, sizeof(buf),
 				 "\"%s%sinitdb\" -D \"%s/data\" --no-clean --no-sync%s%s > \"%s/log/initdb.log\" 2>&1",
-				 bindir ? bindir : "",
-				 bindir ? "/" : "",
+				 libexecdir ? libexecdir : "",
+				 libexecdir ? "/" : "",
 				 temp_instance,
 				 debug ? " --debug" : "",
 				 nolocale ? " --no-locale" : "",
diff --git a/src/tools/msvc/Solution.pm b/src/tools/msvc/Solution.pm
index a13ca6e02e..b43ad7d38a 100644
--- a/src/tools/msvc/Solution.pm
+++ b/src/tools/msvc/Solution.pm
@@ -734,6 +734,7 @@ sub GenerateFiles
 		  || confess "Could not open pg_config_paths.h";
 		print $o <<EOF;
 #define PGBINDIR "/bin"
+#define PGLIBEXECDIR "/libexec"
 #define PGSHAREDIR "/share"
 #define SYSCONFDIR "/etc"
 #define INCLUDEDIR "/include"
diff --git a/src/tools/msvc/vcregress.pl b/src/tools/msvc/vcregress.pl
index 0a98f6e37d..e87c636455 100644
--- a/src/tools/msvc/vcregress.pl
+++ b/src/tools/msvc/vcregress.pl
@@ -136,6 +136,7 @@ sub check
 		"../../../$Config/pg_regress/pg_regress",
 		"--dlpath=.",
 		"--bindir=",
+		"--libexecdir=",
 		"--schedule=${schedule}_schedule",
 		"--max-concurrent-tests=20",
 		"--encoding=SQL_ASCII",
@@ -162,6 +163,7 @@ sub ecpgcheck
 	my @args     = (
 		"../../../../$Config/pg_regress_ecpg/pg_regress_ecpg",
 		"--bindir=",
+		"--libexecdir=",
 		"--dbname=ecpg1_regression,ecpg2_regression",
 		"--create-role=regress_ecpg_user1,regress_ecpg_user2",
 		"--schedule=${schedule}_schedule",
-- 
2.21.1 (Apple Git-122.3)

